#include <iostream>
#include <vector>
#include <ranges>
#include <numeric>

#include <execution>
#include <algorithm>

int main(){
	size_t nbValue(10lu);
	std::vector<float> vecA(nbValue), vecB(nbValue), vecC(nbValue);
	std::iota(vecA.begin(), vecA.end(), 0);
	std::iota(vecB.begin(), vecB.end(), 10);
	std::iota(vecC.begin(), vecC.end(), 100);
	std::cout << "Test with simple zip :" << std::endl;
	for (const auto & [a, b, c] : std::views::zip(vecA, vecB, vecC)) {
		std::cout << "a = " << a << ", b = " << b << ", c = " << c << std::endl;
	}
	std::cout << "Test with zip of repeat :" << std::endl;
	size_t nbRepeat(2lu);
	for (const auto & [a, b, c] : std::views::zip(
			std::views::repeat(vecA, nbRepeat),
			std::views::repeat(vecB, nbRepeat),
			std::views::repeat(vecC, nbRepeat)))
	{
		//For some reason, the repeat gives vector of vector of elements and not only vector of elements, so we can call .front()
		std::cout << "a.front() = " << a.front() << ", b.front() = " << b.front() << ", c.front() = " << c.front() << std::endl;
	}
	return 0;
}
